"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const apollo_server_core_1 = require("apollo-server-core");
function graphqlExpress(options) {
    if (!options) {
        throw new Error('Apollo Server requires options.');
    }
    if (arguments.length > 1) {
        throw new Error(`Apollo Server expects exactly one argument, got ${arguments.length}`);
    }
    const graphqlHandler = (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        const a = apollo_server_core_1.runHttpQuery([req, res], {
            method: req.method,
            options: options,
            query: req.method === 'POST' ? req.body : req.query,
            request: apollo_server_core_1.convertNodeHttpToRequest(req),
        }).then(({ graphqlResponse, graphqlResponses, responseInit }) => { var graphqlResponses_1, graphqlResponses_1_1; return __awaiter(this, void 0, void 0, function* () {
            var e_1, _a;
            Object.keys(responseInit.headers).forEach(key => res.setHeader(key, responseInit.headers[key]));
            if (graphqlResponse) {
                res.setHeader('Content-Length', Buffer.byteLength(graphqlResponse, 'utf8').toString());
                res.write(graphqlResponse);
                res.end();
            }
            else if (graphqlResponses) {
                res.setHeader('Content-Type', 'multipart/mixed; boundary="-"');
                try {
                    for (graphqlResponses_1 = __asyncValues(graphqlResponses); graphqlResponses_1_1 = yield graphqlResponses_1.next(), !graphqlResponses_1_1.done;) {
                        let data = graphqlResponses_1_1.value;
                        res.write(data + '\r\n---\r\n');
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (graphqlResponses_1_1 && !graphqlResponses_1_1.done && (_a = graphqlResponses_1.return)) yield _a.call(graphqlResponses_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                res.write('\r\n---');
                res.end();
            }
        }); }, (error) => {
            if ('HttpQueryError' !== error.name) {
                return next(error);
            }
            if (error.headers) {
                Object.keys(error.headers).forEach(header => {
                    res.setHeader(header, error.headers[header]);
                });
            }
            res.statusCode = error.statusCode;
            res.write(error.message);
            res.end();
        });
    });
    return graphqlHandler;
}
exports.graphqlExpress = graphqlExpress;
//# sourceMappingURL=expressApollo.js.map